diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/include/s_serv.h ircd-hybrid-6b124/include/s_serv.h
--- ircd-hybrid-6b124.orig/include/s_serv.h	Fri Jul 30 01:48:11 1999
+++ ircd-hybrid-6b124/include/s_serv.h	Fri Apr 21 19:52:29 2000
@@ -45,6 +45,10 @@
 #define CAP_EX          0x00000008      /* Can do channel +e exemptions */
 #define CAP_CHW         0x00000010      /* Can do channel wall @# */
 #define CAP_DE          0x00000020      /* Can do channel +d (regex deny) */
+#define CAP_OPN         0x10000000      /* Can do sethost, setident, setname,
+                                           allows opers to hack modes, accepts
+                                           glines without vote, has nicklen 30
+                                           and topiclen 450, etc. etc. */
 
 #define DoesCAP(x)      ((x)->caps)
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/src/s_serv.c ircd-hybrid-6b124/src/s_serv.c
--- ircd-hybrid-6b124.orig/src/s_serv.c	Sun Apr  2 08:59:01 2000
+++ ircd-hybrid-6b124/src/s_serv.c	Fri Apr 21 19:58:49 2000
@@ -73,6 +73,7 @@
   { "EX",       CAP_EX },
   { "CHW",      CAP_CHW },
   { "DE",       CAP_DE },
+  { "OPN",      CAP_OPN },
   { 0,   0 }
 };
 
@@ -565,6 +566,10 @@
   /* Its got identd , since its a server */
   SetGotId(cptr);
 
+  if (!IsCapable(cptr, CAP_OPN)) {
+      sendto_ops("Access denied (not an OPN hax0red server) %s", inpath);
+      return exit_client(cptr, cptr, cptr, "Insufficient Capabilities");
+    }
 #ifndef HUB
   /* Its easy now, if there is a server in my link list
    * and I'm not a HUB, I can't grow the linklist more than 1
@@ -661,7 +666,7 @@
 
   nextping = CurrentTime;
   /* ircd-hybrid-6 can do TS links, and  zipped links*/
-  sendto_ops("Link with %s established: (%s) link",
+  sendto_ops("Link with %s established: %s",
              inpath,show_capabilities(cptr));
 
   add_to_client_hash_table(cptr->name, cptr);
